"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadEventBus = void 0;
const worker_threads_1 = require("worker_threads");
const base_1 = require("./base");
class ThreadEventBus extends base_1.AbstractEventBus {
    workerSubscribeMessage(subscribeMessageHandler) {
        worker_threads_1.parentPort.on('message', subscribeMessageHandler);
    }
    workerListenMessage(worker, subscribeMessageHandler) {
        worker.on('message', subscribeMessageHandler);
    }
    workerSendMessage(message) {
        worker_threads_1.parentPort.postMessage(message);
    }
    mainSendMessage(worker, message) {
        worker.postMessage(message);
    }
    isMain() {
        return !this.isWorker();
    }
    isWorker() {
        var _a;
        return (_a = this.options.isWorker) !== null && _a !== void 0 ? _a : !worker_threads_1.isMainThread;
    }
    getWorkerId(worker) {
        return String(worker ? worker.threadId : worker_threads_1.threadId);
    }
}
exports.ThreadEventBus = ThreadEventBus;
//# sourceMappingURL=thread.js.map